use crate::ir::Fn;

enum Value {
    I32(i32),
    U32(u32),
    StaticPtr(u32),
    Fn(u32),
}

struct Vm<'a> {
    fns: &'a Vec<Fn>,
    call_stack: Vec<(u64, i32)>,
    value_stack: Vec<Value>,
}

impl<'a> Vm<'a> {
    pub fn new(fns: &'a Vec<Fn>) -> Self {
        Self {
            fns,
            call_stack: Vec::new(),
            value_stack: Vec::new(),
        }
    }

    pub fn run(&mut self, entry: u64) {}
}
